/*
$Name: Release_1_2 $
$Header: /home/CVSrepository/concordancer/standard.h,v 1.3 2000/03/26 20:50:12 ralph Exp $
$Author: ralph $
$Locker:  $
$State: Exp $
$Log: standard.h,v $
Revision 1.3  2000/03/26 20:50:12  ralph
Added facility to count pages via counting lines and formfeeds and to enable
the number of lines to be considered a page to be input.
Updated the man page to include this new facility.
Updated the instructions when help is asked on the command line to include
the new facility.  Changes were made in main() and in parse() for this.

Revision 1.2  2000/03/26 13:04:36  ralph
Changed some instructions.
Removed causes of occasional seg fault errors due to bad parsing of
input args in curious cases.

Revision 1.1.1.1  2000/01/02 17:33:33  ralph
Initial importation to CVS

*/
/*
*/
/*************************************************************
*File: STANDARD.H - standard program header containing various general conventions
*
* Copyright (C) 11-13-93 Ralph L. Meyer - R & R Consulting
* 39 Nelson Avenue, Monroe Twp., NJ 08831-8708
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* Bug reports and suggestions can be sent to:
* meyer@@princeton.edu
* Ralph L. Meyer, 39 Nelson Ave. Monroe Twp., NJ 08831-8708
*
Project #: .
Standard header file
**************************************************************/
#include "oshdr.h"

#ifndef _STANDARDHDR_
#define _STANDARDHDR_

#include <stdio.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include <ctype.h>

#ifdef DOS_FUNCS
#include <curses.h>
#endif

//colors for Ioblock windows, messages, etc:
#define PROMPTCOLOR WHITE        //Prompt messages at bottom of screen
#define ERRORCOLOR LIGHTRED      //error messages at bottom of screen
#define LABELCOLOR YELLOW        //entry window label colors
#define LABELBACKGROUND BLACK
#define WINDOWCOLOR LIGHTCYAN    //entry window colors
#define WINDOWBACKGROUND BLUE

#define REVCOLOR BLUE            //reversed menu window colors
#define REVBACKGROUND WHITE
#define BORDERCOLOR LIGHTRED     //menu window border colors
#define BORDERBACKGROUND BLUE
#define NORMALCOLOR  LIGHTGRAY
#define NORMALBACKGROUND BLACK

//key scancodes:
#define DNARROW 80   //keytype: 0
#define UPARROW 72   //    0
#define RTARROW 77   //    0
#define LTARROW 75   //    0
#define ENTER  13 //    1
#define CR  13 //    1
#define LF  10 //    1
#define DEL 83 //    0
#define BKSP    8 //    1
#define HOME   71 //    0
#define INSERT 82 //    0
#define END 79 //    0
#define ESC 27 //    1
#define F1KEY  59 //    0

//ASCII code(s)
#define FF  12 //formfeed

/* boolean flags */
typedef enum Boolean {FALSE=0,TRUE=1,FAIL=0,SUCCEED=1,OK=1,NO=0,YES=1,NOMSG=0,MSG=1,OFF=0,ON=1} BOOLEAN;

//typedef enum Boolean {FAIL=0,SUCCEED=1,OK=1,NO=0,YES=1,NOMSG=0,MSG=1,OFF=0,ON=1} BOOLEAN;

//calendar enumerations:
typedef enum {JAN,FEB,MAR,APR,MAY,JUN,JUL,AUG,SEP,OCT,NOV,DEC} MONTH;
typedef enum {SUN, MON, TUE, WED, THU, FRI, SAT, WEEK} DAY;

const int errlocx=5;   //x screen location of error message beginning
const int errlocy=25;  //y screen location of error message beginning

//enumeration of days of the year to the end of each month in the year
enum {
   JANBEG=  0,
   JANEND= 31,     //31
   FEBEND= 59,     //28 Note: leap years have 29!
	 FEBLEND=60,
   MAREND= 90,     //31
	 MARLEND=91,
   APREND=120,     //30
	 APRLEND=121,
   MAYEND=151,     //31
	 MAYLEND=152,
   JUNEND=181,     //30
	 JUNLEND=182,
   JULEND=212,     //31
	 JULLEND=213,
   AUGEND=243,     //31
	 AUGLEND=244,
   SEPEND=273,     //30
	 SEPLEND=274,
   OCTEND=304,     //31
	 OCTLEND=305,
   NOVEND=334,     //30
	 NOVLEND=335,
   DECEND=365,     //31
	 DECLEND=366
};                 //365 ; LEAP YEAR END: 366

#endif
